sub cgiReadInput {
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});}
	if ($ENV{'REQUEST_METHOD'} eq 'GET') {$query_string = $ENV{'QUERY_STRING'};}

	@pairs = split(/&/, $query_string);

	foreach $field(@pairs) {
		($name, $value) = split(/=/, $field);
		$name = &strURLDecode($name);
		$value = &strURLDecode($value);

	    $FORM{$name} = $value;
	}

	$cookie_string = $ENV{'HTTP_COOKIE'};
	@pairs = split(/; /, $cookie_string);

	foreach $field(@pairs) {
	($name, $value) = split(/=/, $field);
		$name = &strURLDecode($name);
		$value = &strURLDecode($value);

		$COOKIE{$name} = $value;
	}
}


sub strURLEncode {
	$str = '';

	for ($i = 0; $i < length($_[0]); $i++) {
		$tok = substr($_[0], $i, 1);
		if ($tok =~ /[ 0-9A-Za-z@.]/) {
			if ($tok =~ / /) { $str .= "+"; }
			else { $str .= $tok; }
		}
		else {
			$str .= "%";
			$str .= sprintf("%02X", ord($tok));
		}
	}

	$str;
}

sub strURLDecode {
	$str = $_[0];

	$str =~ tr/+/ /;
	$str =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/egi;

	$str;
}


sub cgiSetCookie {
	$name = $_[0];
	$value = $_[1];

	$name = &strURLEncode($name);
	$value = &strURLEncode($value); 

	print "Set-Cookie: $name=$value;expires=Thu, 31-Dec-2099 00:00:00 GMT;path=;domain=www.webweaver.pe.kr;\r\n";
} 
  

sub cgiErrorMsg {
	print <<END_OF_MESSAGE;
Content-type: text/html

<HTML>
<HEAD>
  <TITLE> Error !! </TITLE>
</HEAD>
<BODY onLoad=\"alert('$_[0]');history.back()\">
</BODY>
</HTML>
END_OF_MESSAGE

	exit;
}

return 1;